//**********************************************************************
//		ys.co.jp oXPbgVXe
//
//		Title:		Rg[}X^[NX
//		FileName:	Contrxxxaster.java
//		Creator:	Shinichi Aizawa
//		CreateDate:	2000/04/14
//**********************************************************************

import java.text.DecimalFormat;
import java.io.IOException;
import java.sql.*;
import javax.servlet.ServletException;

// Rg[}X^[pNX
public class Contrxxxaster
{
	// ViR[h擾
	public String GetNewShouhinCode()
			throws ServletException, IOException, SQLException {

		int code = GetNewCode("MCN_SHOUHIN_CODE");

		DecimalFormat form = new DecimalFormat("00000");
		return form.format(code);
	}

	// V[UR[h擾
	public String GetNewUserCode()
			throws ServletException, IOException, SQLException {

		int code = GetNewCode("MCN_USER_CODE");

		DecimalFormat form = new DecimalFormat("000000");
		return form.format(code);
	}

	// VAP[gR[h擾
	public String GetNewEnqueteCode()
			throws ServletException, IOException, SQLException {

		int code = GetNewCode("MCN_ENQUETE_CODE");

		DecimalFormat form = new DecimalFormat("000000");
		return form.format(code);
	}

	// V󒍃R[h擾
	public String GetNewJuchuCode()
			throws ServletException, IOException, SQLException {

		int code = GetNewCode("MCN_JUCHU_CODE");

		DecimalFormat form = new DecimalFormat("000000");
		return form.format(code);
	}

	// VR[h擾ʏ
	private int GetNewCode(String name)
			throws ServletException, IOException, SQLException {

		// f[^x[Xڑ
		DataBase db = new DataBase();
		Statement st = db.createStatement();

		// selects
		String sql = "select " + name + " from M_CONTROL";
		ResultSet rs = st.executeQuery(sql);
		if (!rs.next()) {
			// 擾łȂO𔭐
			throw new ServletException("Not found Control master");
		}

		// ̃R[h擾
		int icode = rs.getInt(1);

		// R[h{P
		sql = "update M_CONTROL set " + name + "=" + (icode + 1);
		st.executeUpdate(sql);

		// f[^x[XN[Y
		rs.close();
		st.close();

		return icode;
	}

	// iR[hLZ
	public void CancelShouhinCode(String code)
			throws ServletException, IOException, SQLException {
		CancelCode("MCN_SHOUHIN_CODE", code);
	}

	// [U[R[hLZ
	public void CancelUserCode(String code)
			throws ServletException, IOException, SQLException {
		CancelCode("MCN_USER_CODE", code);
	}

	// R[hLZʏ
	private void CancelCode(String name, String code)
			throws ServletException, IOException, SQLException {

		// f[^x[Xڑ
		DataBase db = new DataBase();
		Statement st = db.createStatement();

		// selects
		String sql = "select " + name + " from M_CONTROL";
		ResultSet rs = st.executeQuery(sql);
		if (!rs.next()) {
			// 擾łȂO𔭐
			throw new ServletException("Not found Control master");
		}

		// ̃R[h擾
		int icode = rs.getInt(1);

		// ÕLZR[hЂƂ߂
		if (icode == Integer.parseInt(code) + 1) {
			sql = "update M_CONTROL set " + name + "=" + (icode - 1);
			st.executeUpdate(sql);
		}

		// f[^x[XN[Y
		rs.close();
		st.close();
	}

	// Ǘҗphc^pX[h`FbN
	public boolean CheckAdmin(String id, String password)
			throws ServletException, IOException, SQLException {

		// f[^x[Xڑ
		DataBase db = new DataBase();
		Statement st = db.createStatement();

		// selects
		String sql = "select MCN_ADMIN_ID,MCN_ADMIN_PASS from M_CONTROL";
		ResultSet rs = st.executeQuery(sql);
		if (!rs.next()) {
			// 擾łȂO𔭐
			throw new ServletException("Control master read failed.");
		}

		// hcƃpX[hvĂ邩`FbN
		boolean result = id.equals(rs.getString("MCN_ADMIN_ID").trim())
				&& password.equals(rs.getString("MCN_ADMIN_PASS").trim());

		// f[^x[XN[Y
		rs.close();
		st.close();

		return result;
	}
	// [MNX
	class MailInfo {
		String MailServer;
		String ToAddress;
		String CcAddress;
		String FromAddress;
	}
	// [M擾
	public MailInfo GetMailInfo()
			throws ServletException, IOException, SQLException {

		// f[^x[Xڑ
		DataBase db = new DataBase();
		Statement st = db.createStatement();

		// selects
		String sql = "select * from M_CONTROL";
		ResultSet rs = st.executeQuery(sql);
		if (!rs.next()) {
			// 擾łȂO𔭐
			throw new ServletException("Not found Control master");
		}

		// [CX^X
		MailInfo mailinfo = new MailInfo();

		// [CX^XNXɃZbg
		mailinfo.MailServer = rs.getString("MCN_MAIL_SERVER");
		mailinfo.ToAddress = rs.getString("MCN_MAIL_TO");
		mailinfo.CcAddress = rs.getString("MCN_MAIL_CC");
		mailinfo.FromAddress = rs.getString("MCN_MAIL_FROM");

		// f[^x[XN[Y
		rs.close();
		st.close();

		return mailinfo;
	}
}
