//**********************************************************************
//		ys.co.jp oXPbgVXe
//
//		Title:		oXPbgVXe{NX
//		FileName:	BaseServlet2.java
//		Creator:	Shinichi Aizawa
//		CreateDate:	2000/04/14
//**********************************************************************

import java.io.IOException;
import java.io.PrintWriter;
import java.io.OutputStreamWriter;
import java.util.StringTokenizer;
import java.sql.SQLException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;
import javax.servlet.http.HttpSession;

// oXPbgVXeʋʊ{NX
public abstract class BaseServlet2 extends HttpServlet {

	// o͕R[h
	protected final String Encoding = "iso-2022-jp";

	// ysgbvy[WURL
	protected final String TopPage = "/index.html";

	// 摜t@CpX
	protected final String pictLogicalPath = "/pict/";

	// "GET"\bh
	public void doGet(HttpServletRequest request, HttpServletResponse response) 
			throws ServletException, IOException {

		try {
			// ContentTypeݒ肨PrintWriter擾
			response.setContentType("text/html; charset=" + Encoding);
			//PrintWriter pw = response.getWriter();
			PrintWriter pw = new PrintWriter(new OutputStreamWriter(response.getOutputStream(), response.getCharacterEncoding()), true);

			// ZbV擾
			HttpSession session = request.getSession(false);
			if (session == null) {
				SessionFailure(response);
				return;
			}

			// ZbVI[_擾
			Order order = (Order)session.getValue("order");
			if (order == null) {
				SessionFailure(response);
				return;
			}

			// ̓p[^擾NX
			Param param = new Param(request);

			// doGet()ʏ
			doGetHandler(response, pw, session, param, order);
		} catch (Exception e) {
			throw new ServletException(e.toString());
		}
	}

	// doGet()ʏ̃ftHgiȂj
	protected void doGetHandler(HttpServletResponse response, PrintWriter pw, HttpSession session, Param param, Order order)
			throws ServletException, IOException, SQLException {
	}

	// "POST"\bh
	public void doPost(HttpServletRequest request, HttpServletResponse response) 
			throws ServletException, IOException {

		try {
			// ContentTypeݒ肨PrintWriter擾
			response.setContentType("text/html; charset=iso-2022-jp");
			//PrintWriter pw = response.getWriter();
			PrintWriter pw = new PrintWriter(new OutputStreamWriter(response.getOutputStream(), response.getCharacterEncoding()), true);

			// ZbV擾
			HttpSession session = request.getSession(false);
			if (session == null) {
				SessionFailure(response);
				return;
			}

			// ZbVI[_擾
			Order order = (Order)session.getValue("order");
			if (order == null) {
				SessionFailure(response);
				return;
			}

			// ̓p[^擾NX
			Param param = new Param(request);

			// doPost()ʏ
			doPostHandler(response, pw, session, param, order);
		} catch (Exception e) {
			throw new ServletException(e.toString());
		}
	}

	// doPost()ʏ̃ftHgiȂj
	protected void doPostHandler(HttpServletResponse response, PrintWriter pw, HttpSession session, Param param, Order order)
			throws ServletException, IOException, SQLException {
	}

	// wb_o͏ititle ƌoj
	protected void Header(PrintWriter pw, String title, String bodyOpt) {
		Header(pw, title, title, bodyOpt);
	}

	// wb_o͏ititle ƌoʁj
	protected void Header(PrintWriter pw, String title, String pagename, String bodyOpt) {
		pw.println("<html>");
		pw.println("<head>");
		pw.println("<META HTTP-EQUIV='Content-Type' CONTENT='text/html; charset=" + Encoding + "'>");
		pw.println("<META HTTP-EQUIV='Pragma' CONTENT='no-cache'>");
		pw.println("<link rel='stylesheet' href='/css.txt'>");
		pw.println("<title>"+title+"</title>");
		pw.println("</head>");
		pw.println("<body " + bodyOpt + ">");
		pw.println("<h2>" + pagename + "</h2>");
		pw.println("<p>");
	}

	// tb^o͏
	protected void Footer(PrintWriter pw) {
		pw.println("</body>");
		pw.println("</html>");
	}

	// G[pbZ[Wo
	protected void Failure(PrintWriter pw, String reason) {
		pw.println("<br>");
		pw.println("ȉ̌QlɂĉB:");
		pw.println("<p>");
		pw.println(reason);
		pw.println("<p>");
		pw.println("ȂAs̗Rs̏ꍇ ");
		pw.println("<a href='mailto:servlet-admin@java-conf.gr.jp'>");
		pw.println("T[oǗl</a> ܂łm点B");
	}

	// JavaScripto͏
	protected void JavaScript(PrintWriter pw, String[] script) {
		int i;

		pw.println("<script language='JavaScript'><!--");

		for (i = 0; i < script.length; i++) {
			pw.println(script[i]);
		}

		pw.println("// --></script>");
	}

	// ZbVؒf̏i݂͓ɖ߂j
	protected void SessionFailure(HttpServletResponse response)
			throws IOException {

/*
		Init(response);
		Header("Timeout", "", "bgcolor='#CCFFFF'");
		pw.println("<h2>񂪎ꂽߏpł܂B<br>");
		pw.println("\󂠂܂񂪁Axŏ͂ĂB</h2>");
		pw.println("<a href='Kensaku'>iy[Wɖ߂</a>");
		Footer();
*/
		response.sendRedirect("entry");
	}

	// uN̍ڂ<br>o͂ig\邽߁j
	protected String ConvertBlank(String text) {

		text = text.trim();
		if (text == null || text.equals(""))
			text = "<br>";

		return text;
	}

	// f[^ɉs <br> ɕϊ
	protected String ConvertCRLF(String in) {
		StringTokenizer st = new StringTokenizer(in, "\n");
		String out = "";

		int count = st.countTokens();
		while (--count >= 0) {
			out += st.nextToken() + "<br>";
		}

		return out;
	}
}
