//**********************************************************************
//		ys.co.jp oXPbgVXe
//
//		Title:		󒍏mF
//		FileName:	OrderVerify.java
//		Creator:	Shinichi Aizawa
//		CreateDate:	2000/04/14
//**********************************************************************

import java.util.*;
import java.text.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.*;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletException;

// iI[_mFy[WNX
public class OrderVerify extends BaseServlet2
{
	// "GET"\bh
	protected void doGetHandler(HttpServletResponse response, PrintWriter pw, HttpSession session, Param param, Order order)
			throws ServletException, IOException, SQLException {

		Header(pw, "󒍏", "", "bgcolor='#FFFFCC'");
		Body(pw, order);
		Footer(pw);
	}

	// {̕htmlo͏
	private void Body(PrintWriter pw, Order order)
			throws ServletException, IOException, SQLException {

		MyUtil myutil = new MyUtil();
		DecimalFormat fmt = new DecimalFormat("#,###,###");
		Order.Juchu juchu = order.juchu;

		pw.println("<p align='center' class='s5'><font color='#000000'>" + order.user.Shimei + "l@󒍊mF</font></p>");
		pw.println("<p align='center' class='s1'> <font color='#000000'><br>");
		pw.println("</font></p>");
		pw.println("<div align='center'>");
		pw.println("<table width='560' border='2' cellspacing='1' cellpadding='1' class='s1' bgcolor='#CCFFFF' height='62'>");

		int count = order.GetMeisaiNum();
		for (int i = 0; i < count; i++) {
			Order.Meisai meisai = order.GetMeisai(i);

			pw.println("<tr>");
			pw.println("<td width='60' nowrap><font color='#000000'>" + meisai.ShouhinNo + "</font></td>");
			pw.println("<td width='241' nowrap><font color='#000000'>" + meisai.ShouhinName + "</font></td>");
			pw.println("<td width='74' nowrap><font color='#000000'>" + meisai.Kosuu + meisai.Tani + "</font></td>");
			pw.println("<td width='163' nowrap>");
			pw.println("<div align='right'><font color='#000000'>" + fmt.format(meisai.Shoukei) + "~</font></div>");
			pw.println("</td>");
			pw.println("</tr>");
		}

		pw.println("<tr>");
		pw.println("<td colspan='4' nowrap>");
		pw.println("<div align='right'> <font color='#000000'>vziōj@" + fmt.format(order.juchu.Total) + "~</font></div>");
		pw.println("</td>");
		pw.println("</tr>");
		pw.println("</table>");
		pw.println("<br>");

		pw.println("<span class='s1'><font color='#FF0000'>");
		pw.println("L̍vz̑ɑi700~jpӂB<br>");
		pw.println("z]͑̑̕Ɏ萔i400~j𒸂܂B<br>");
		pw.println("A15,000~ȏエグ̏ꍇAA萔͖ƂĂ܂B<br>");
		pw.println("܂AHABʐ^WɊւẮAE萔́AƂȂ܂BqlAHABʐ^W<br>");
		pw.println("Ƒ̏i𓯎ɁAwꍇE萔́A܂BƂȂ܂B");
		pw.println("</font> </span><br>");

		pw.println("</div>");
		pw.println("<br>");
		pw.println("<table cellpadding=8>");
		pw.println("<tr>");
		pw.println("<td align='right'><font color='#000000'>X֔ԍ</td>");
		pw.println("<td>" + juchu.Zip + "</font></td>");
		pw.println("</tr><tr>");
		pw.println("<td align='right'><font color='#000000'>Z</td>");
		pw.println("<td>" + juchu.Address + "</font></td>");
		pw.println("</tr><tr>");
		pw.println("<td align='right'><font color='#000000'>͂挚</td>");
		pw.println("<td>" + juchu.Tatemono + "</font></td>");
		pw.println("</tr><tr>");
		pw.println("<td align='right'><font color='#000000'>͂dbԍ</td>");
		pw.println("<td>" + juchu.TelNo + "</font></td>");
		pw.println("</tr><tr>");
		pw.println("<td align='right'><font color='#000000'>x@</td>");
		pw.println("<td>" + myutil.GetShiharaiName(juchu.Shiharai) + "</font></td>");
		pw.println("</tr>");
		pw.println("</table>");
		pw.println("<form name='form1' method='post'>");
		pw.println("<font color='#000000'>");
		pw.println("<div align='center'>");
		pw.println("<input type='submit' name='ok' value=' M '>");
		pw.println("<input type='submit' name='cancel' value='߂'>");
		pw.println("</div>");
		pw.println("</font>");
		pw.println("</form>");
	}

	// "POST"\bh
	protected void doPostHandler(HttpServletResponse response, PrintWriter pw, HttpSession session, Param param, Order order)
			throws ServletException, IOException, SQLException {

		// NbNꂽ{^ɂU蕪
		if (param.GetParam("ok") != null) {
			// uMv{^NbNꂽ󒍏f[^x[Xɕۑƃ[̑M
			if (StoreDB(order))
				SendOrderMail(order);
			response.sendRedirect("thankyou");
		} else if (param.GetParam("cancel") != null) {
			// u߂v{^NbNꂽgbvy[Wɖ߂
			response.sendRedirect(TopPage);
		}
	}

	// 󒍏ۑ
	private boolean StoreDB(Order order)
			throws ServletException, IOException, SQLException {

		Contrxxxaster cm = new Contrxxxaster();
		DecimalFormat mf = new DecimalFormat("000");
		boolean result = false;

		// f[^x[Xڑ
		DataBase db = new DataBase();
		db.Transaction();
		Statement st = db.createStatement();

		try {
			// 󒍏ۑ
			Order.Juchu juchu = order.juchu;
			juchu.JuchuCode = cm.GetNewJuchuCode();
			juchu.JuchuDate = new java.util.Date();
			juchu.UserCode = order.user.UserCode;
			juchu.Over18Flag = order.user.Over18Flag;
			String sql = "insert into F_JUCHU values ("
					+ "'" + juchu.JuchuCode + "',"
					+ "'" + juchu.JuchuDate + "',"
					+ "'" + juchu.UserCode + "',"
					+ juchu.Over18Flag + ","
					+ "'" + juchu.Zip + "',"
					+ "'" + juchu.Address + "',"
					+ "'" + juchu.Tatemono + "',"
					+ "'" + juchu.TelNo + "',"
					+ "'" + juchu.Total + "',"
					+ "'" + juchu.Shiharai + "')";
			st.executeUpdate(sql);

			// 󒍖וۑ
			int count = order.GetMeisaiNum();
			for (int i = 0; i < count; i++) {
				Order.Meisai meisai = order.GetMeisai(i);
				meisai.MeisaiCode = mf.format(i + 1);
				sql = "insert into F_JUCHUMEISAI values ("
						+ "'" + juchu.JuchuCode + "',"
						+ "'" + meisai.MeisaiCode + "',"
						+ "'" + meisai.ShouhinNo + "',"
						+ "'" + meisai.ShouhinName + "',"
						+ meisai.HanbaiKakaku + ","
						+ meisai.Kosuu + ","
						+ meisai.Shoukei + ")";
				st.executeUpdate(sql);
			}

			// ȂR~bg
			db.Commit();

			result = true;
		} catch (SQLException e) {
			// G[Ȃ烍[obN
			db.Rollback();
		}

		st.close();

		return result;
	}

	// [M
	private void SendOrderMail(Order order)
			throws ServletException, IOException, SQLException {

		Order.User user = order.user;
		Contrxxxaster.MailInfo mailinfo = new Contrxxxaster().GetMailInfo();
		SendMail mail = new SendMail();

		// S҂ă[M
		if (!user.UserID.equals("aizawa"))
		mail.send(mailinfo.MailServer, mailinfo.ToAddress, mailinfo.CcAddress, mailinfo.FromAddress, "[Kairaku-DB]i󒍊mF", MailBodyTantosha(order));

		// w[Uă[M
		mail.send(mailinfo.MailServer, user.EMail, null, mailinfo.FromAddress, "[OnLineShop<F-net>]肪Ƃ܂", MailBodyUser(order));
	}

	// S҂ă[{쐬
	private String MailBodyTantosha(Order order)
			throws ServletException, IOException, SQLException {

		DecimalFormat decfmt = new DecimalFormat("#,###,###");
		SimpleDateFormat datefmt = new SimpleDateFormat("yyyyNMMdd");
		MyUtil myutil = new MyUtil();
		Order.Juchu juchu = order.juchu;
		Order.User user = order.user;

		String text = "@ysf[^x[X@\n"
				+ "\n" 
				+ "ȉ̉珤î܂̂\n" 
				+ "e]v܂B\n" 
				+ "\n"
				+ "mn\n"
				+ "--------------------------------------------------------\n";

		int count = order.GetMeisaiNum();
		for (int i = 0; i < count; i++) {
			Order.Meisai meisai = order.GetMeisai(i);
			text += meisai.ShouhinNo + "@"
					+ meisai.ShouhinName + "@"
					+ meisai.Kosuu + meisai.Tani + "@"
					+ decfmt.format(meisai.Shoukei) + "~\n";
		}

		text += "--------------------------------------------------------\n"
				+ "v " + decfmt.format(juchu.Total) + "~\n"
				+ "\n"
				+ "m͂n\n"
				+ "@󒍓F" + datefmt.format(juchu.JuchuDate) + "\n"
				+ "@F" + user.Shimei + "\n"
				+ "@X֔ԍF" + juchu.Zip + "\n"
				+ "@ZF" + juchu.Address + "\n"
				+ "@F" + juchu.Tatemono + "\n"
				+ "@dbԍF" + juchu.TelNo + "\n"
				+ "@x@F" + myutil.GetShiharaiName(juchu.Shiharai) + "\n"
				+ "\n"
				+ "m[U[n\n"
 				+ "@[U[hcF" + user.UserID + "\n"
				+ "@pX[hF" + user.Password + "\n"
				+ "@o^F" + datefmt.format(user.Touroku) + "\n"
				+ "@ӂ肪ȁF" + user.Furigana + "\n"
				+ "@F" + user.Shimei + "\n"
				+ "@ʁF" + user.Seibetsu + "\n"
				+ "@NF" + user.SeiNen + "N" + user.SeiTsuki + "" + user.Sexxx + "" + "\n"
				+ "@NF" + user.Nenrei + "\n"
				+ "@18ΈȏmFF" + user.Over18Flag + "\n"
				+ "@18ΈȏmFF" + myutil.DateToString(user.Over18Date) + "\n"
				+ "@EƁF" + myutil.GetShokugyouName(user.Shokugyou) + "\n"
				+ "@X֔ԍF" + user.Zip + "\n"
				+ "@ZF" + user.Address + "\n"
				+ "@F" + user.Tatemono + "\n"
				+ "@dbԍF" + user.TelNo + "\n"
				+ "@e`wԍF" + user.FaxNo + "\n"
				+ "@[AhXF" + user.EMail + "\n"
				+ "@[OXgo^F" + user.MailingList + "\n"
				+ "@tqkF" + user.Url + "\n"
				+ "\n"
				+ "mailed by JapanLinkServer\n"
				+ "inquire to mc@japanlink.ne.jp\n";
 
		return text;
	}

	// o^[Uă[{쐬
	private String MailBodyUser(Order order)
			throws ServletException, IOException, SQLException {

		DecimalFormat decfmt = new DecimalFormat("#,###,###");
		MyUtil myutil = new MyUtil();
		Order.Juchu juchu = order.juchu;
		Order.User user = order.user;

		String text = user.Shimei + "@l\n\n";
		text += " ys@e \n";

		text += "--------------------------------------------------------\n";
		int count = order.GetMeisaiNum();
		for (int i = 0; i < count; i++) {
			Order.Meisai meisai = order.GetMeisai(i);
			text += meisai.ShouhinNo + "@"
					+ meisai.ShouhinName + "@"
					+ meisai.Kosuu + meisai.Tani + "@"
					+ decfmt.format(meisai.Shoukei) + "~\n";
		}
		text += "--------------------------------------------------------\n";
		text += "v " + decfmt.format(juchu.Total) + "~\n\n";

		text += "󒍔ԍF" + juchu.JuchuCode + "\n"
				+ "͂X֔ԍF" + juchu.Zip + "\n"
				+ "͂ZF" + juchu.Address + "\n"
				+ "͂挚F" + juchu.Tatemono + "\n"
				+ "͂dbԍF" + juchu.TelNo + "1\n"
				+ "x@F" + myutil.GetShiharaiName(juchu.Shiharai) + "\n"
				+ "\n"
				+ ShiharaiGuide(juchu.Shiharai)
				+ "\n"
				+ "********************************************** \n"
				+ "߂Ă̕ցi18ΈȏNmF܂̕j \n"
				+ "\n"
				+ "18Έȏ̔NmFł镨Ays܂FAXA܂͂tĂB\n"
				+ "\n"
				+ "[tEA]\n"
				+ "162-0814@sVhV쒬3-10SEr4F ysꎖ\n"
				+ "TEL03-5229-7512@FAX03-5229-7513\n"
				+ "\n"
				+ "18Έȏ̊mFoA[ɂĘAv܂B\n"
				+ "܂ŗ̂U荞݂͂ȂŉB\n"
				+ "NmFł܂ŁAi̔͂ł܂B\n"
				+ "**********************************************\n"
				+ "\n"
				+ "肪Ƃ܂B\n";

		return text;
	}

	private String ShiharaiGuide(String ShiharaiCode) {

		String guide = null;

		if (ShiharaiCode.equals("01")) {		// Xֈב
			guide = "Ľցiiv+700~jB\n"
					+ "Aw̍v15,000~ȏ̏ꍇAA萔͖Ƃ\n"
					+ "܂B\n"
					+ "AHABʐ^WɊւẮÁAƂȂ܂B\n"
					+ "qlAHABʐ^WƑ̏i ɁAwꍇ́A܂B\n"
					+ "iv݂̂B\n"
					+ "mFAi𔭑܂B\n"
					+ "@@@@@@@@@@@VhV쒬X֋ǁ@@00160-3-189753\n"
					+ "@@@@@@@@@@@@@@ys\n";
		} else if (ShiharaiCode.equals("02")) {	// sU
			guide = "Ľցiiv+700~jB\n"
					+ "Aw̍v15,000~ȏ̏ꍇAA萔͖Ƃ\n"
					+ "܂B\n"
					+ "AHABʐ^WɊւẮÁAƂȂ܂B\n"
					+ "qlAHABʐ^WƑ̏i ɁAwꍇE萔́A\n"
					+ "܂Biv݂̂B\n"
					+ "mFAi𔭑܂B\n"
					+ " @@@@@@@@@@@ZFs@ѓcxX@ij775751\n"
					+ " @@@@@@@@@@@@@@t[_Gtys\n";
		} else if (ShiharaiCode.equals("03")) {	// 
			guide = "i𔭑܂B\n"
					+ "\n"
					+ "͂iƈɑiiv+700~+萔400~jx\n"
					+ "B\n"
					+ "Aw̍v15,000~ȏ̏ꍇAA萔͖Ƃ\n"
					+ "܂B\n"
					+ "AHABʐ^WɊւẮAE萔́AƂȂ܂B\n"
					+ "qlAHABʐ^WƑ̏i ɁAwꍇE萔́A\n"
					+ "܂B iv݂̂B\n";
		} else if (ShiharaiCode.equals("04")) {	// 
			guide = "mFAi𔭑܂B\n"
					+ "\n"
					+ "͂iƈɑiiv+700~jxB\n"
					+ "Aw̍v15,000~ȏ̏ꍇAA萔͖Ƃ\n"
					+ "܂B\n"
					+ "AHABʐ^WɊւẮÁAƂȂ܂BqlA\n"
					+ "HABʐ^WƑ̏i ɁAwꍇE萔́A܂B\n"
					+ "iv݂̂B\n";
		}

		return guide;
	}
}
