//**********************************************************************
//		ys.co.jp oXPbgVXe
//
//		Title:		i}X^ꗗ
//		FileName:	ShouhinList.java
//		Creator:	Shinichi Aizawa
//		CreateDate:	2000/04/14
//**********************************************************************

import java.io.IOException;
import java.io.PrintWriter;
import java.text.*;
import java.sql.*;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;

// iꗗʏNX
public class ShouhinList extends BaseServlet1
{
	// "GET"\bh
	public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException {

		try {
			// OC`FbN
			if (!LoginCheck(request)) {
				// OCĂȂꍇ͋IɃgbvy[Wɖ߂
				response.sendRedirect(TopPage);
				return;
			}

			MyUtil myutil = new MyUtil();
			Param param = new Param(request);
			PrintWriter pw = GetPrintWriter(response);
			String no;

			// \鎁擾
			no = param.GetParam("no");
			if (no == null)
				no = myutil.GetCookieValue(request, "ShouhinNo");
			else
				myutil.PutCookie(response, "ShouhinNo", no);

			Header(pw, "iꗗ");
			Body(pw, no);
			Footer(pw);
		} catch (Exception e) {
			throw new ServletException(e.toString());
		}
	}

	// {̕htmlo͏
	private void Body(PrintWriter pw, String no)
		throws ServletException, IOException, SQLException {

		String code;
		SimpleDateFormat formatter = new SimpleDateFormat ("yyyy/MM/dd");
		int count = 0;

		// f[^x[Xڑ
		DataBase db = new DataBase();
		Statement st = db.createStatement();
		String sql = "select MSH_SHOUHIN_CODE,MSH_SHOUHIN_NO,MSH_SHOUHIN_NAME,MSB_BUNRUI_NAME,MCT_CATEGORY_NAME,MSH_TOUROKU_DATE"
				+ " from M_SHOUHIN,M_SBUNRUI,M_CATEGORY"
				+ " where MSH_BUNRUI_CODE=MSB_BUNRUI_CODE and MSH_CATEGORY_CODE=MCT_CATEGORY_CODE";
		if (no != null && !no.equals(""))
			sql += " and MSH_SHOUHIN_NO like '" + no + "%'";
		sql += " order by MSH_SHOUHIN_CODE";
		ResultSet rs = st.executeQuery(sql);

		// Jwb_o
		pw.println("<table border=1 width='96%' bgcolor='#E0FFE0'>");
		pw.println("<tr bgcolor='#FFE0E0'>");
		pw.println("<th width='9%'>iR[h</th>");
		pw.println("<th width='15%'>iԍ</th>");
		pw.println("<th width='38%'>i</th>");
		pw.println("<th width='10%'>i</th>");
		pw.println("<th width='18%'>JeS[</th>");
		pw.println("<th width='10%'>o^</th>");
		pw.println("</tr>");

		// R[ho
		while (rs.next()) {
			pw.println("<tr>");
			code = rs.getString(1);
			pw.println("<td><a href='ShouhinItem?code=" + code + "'>" + code + "</td>");
			pw.println("<td>" + rs.getString(2) + "</td>");
			pw.println("<td>" + rs.getString(3) + "</td>");
			pw.println("<td>" + rs.getString(4) + "</td>");
			pw.println("<td>" + rs.getString(5) + "</td>");
			pw.println("<td>" + formatter.format(rs.getDate(6)) + "</td>");
			pw.println("</tr>");
			count++;
		}
		pw.println("</table>");

		// \
		pw.println("<div align='right'>F" + count + "</div>");

		// f[^x[XN[Y
		rs.close();
		st.close();
	}
}
